window.Gleam.initSearch([{"doc":"pinkdf2","title":"pinkdf2","content":"# pinkdf2\n\n[![Package Version](https://img.shields.io/hexpm/v/pinkdf2)](https://hex.pm/packages/pinkdf2)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/pinkdf2/)\n\nA Gleam implementation of PBKDF2 (Password-Based Key Derivation Function 2) for Erlang. Heavily indebted to [erlang-pbkdf2](github.com/whitelynx/erlang-pbkdf2).\n\n```sh\ngleam add pinkdf2@1\n```\n```gleam\nimport pinkdf2\n\npub fn main() {\n  let assert Ok(key) = pinkdf2.with_defaults(&quot;password&quot;, pinkdf2.get_salt())\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/pinkdf2&gt;.\n","url":"index.html"},{"doc":"pinkdf2","title":"Pbkdf2Error","content":"pub type Pbkdf2Error {\n  UnsupportedAlgorithm(String)\n  KeyDerivedLengthTooLong\n}\n\nUnsupportedAlgorithm(String)\n\n\nKeyDerivedLengthTooLong\n\n\nSynonyms:\npinkdf2.Pbkdf2Error\npinkdf2 Pbkdf2Error","url":"pinkdf2.html#Pbkdf2Error"},{"doc":"pinkdf2","title":"Pbkdf2Keys","content":"pub type Pbkdf2Keys {\n  Pbkdf2Keys(raw: BitArray, base64: String)\n}\n\nPbkdf2Keys(raw: BitArray, base64: String)\n\n\nSynonyms:\npinkdf2.Pbkdf2Keys\npinkdf2 Pbkdf2Keys","url":"pinkdf2.html#Pbkdf2Keys"},{"doc":"pinkdf2","title":"get_salt","content":"pub fn get_salt() -&gt; String\n Generates a base64-encoded salt with a minimum size of 64 bytes.\n It is provided here for convenience, but it is based on the same underlying Erlang function as `crypto.strong_rand_bytes`.\nSynonyms:\npinkdf2.get_salt\npinkdf2 get_salt","url":"pinkdf2.html#get_salt"},{"doc":"pinkdf2","title":"with_config","content":"pub fn with_config(\n  alg: HashAlgorithm,\n  password: String,\n  salt: String,\n  iterations: Int,\n  d_len: Int,\n) -&gt; Result(Pbkdf2Keys, Pbkdf2Error)\n Derives a key using the provided configuration.\n\n `alg` may be any algorithm from `crypto.HashAlgorithm` except for `Md5` and `Sha1`.\n &#39;d_len&#39; is the targeted derived key length in bytes.\n\n ## Examples\n\n \n import gleam/crypto\n import pinkdf2\n\n let salt = pinkdf2.get_salt()\n let assert Ok(key) = pinkdf2.with_config(crypto.Sha512, &quot;password&quot;, salt, 210_000, 32)\n \nSynonyms:\npinkdf2.with_config\npinkdf2 with_config","url":"pinkdf2.html#with_config"},{"doc":"pinkdf2","title":"with_defaults","content":"pub fn with_defaults(\n  password: String,\n  salt: String,\n) -&gt; Result(Pbkdf2Keys, Pbkdf2Error)\n Derives a key from a password and salt with default settings based on the\n (OWASP recommendations)[https://cheatsheetseries.owasp.org/cheatsheets/Password_Storage_Cheat_Sheet.html#pbkdf2].\nSynonyms:\npinkdf2.with_defaults\npinkdf2 with_defaults","url":"pinkdf2.html#with_defaults"},{"doc":"pinkdf2","title":"pinkdf2","content":" Password-Based Key Derivation Function 2 in Gleam for Erlang as defined in RFC 2898\n https://datatracker.ietf.org/doc/html/rfc2898","url":"pinkdf2.html"}]);